<template>
    <div class="wrapper">
        <loading :active.sync="loading" is-full-page></loading>
        <div class="md-layout">
            <div class="md-layout-item">
                <!-- <md-card style="margin:0px"> -->
                <carousel :per-page="1" loop :speed="700" autoplay :autoplay-timeout="5000" :mouse-drag="true" paginationPosition="bottom-overlay">
                    <!-- <carousel :per-page="1" loop :speed="700" autoplay :autoplay-timeout="5000" :mouse-drag="false" navigationEnabled navigationNextLabel="<i class='material-icons'>keyboard_arrow_right</i>" navigationPrevLabel="<i class='material-icons'>keyboard_arrow_left</i>"> -->
                    <slide>
                        <!-- <div class="carousel-caption">
                            <h4>
                                <md-icon>location_on</md-icon>
                                Somewhere Beyond, United States
                            </h4>
                        </div> -->
                        <img :src="carousel1" alt="carousel1" />
                    </slide>
                    <slide>
                        <!-- <div class="carousel-caption">
                            <h4>
                                <md-icon>location_on</md-icon>
                                Yellowstone National Park, United States
                            </h4>
                        </div> -->
                        <img :src="carousel3" alt="carousel3" />
                    </slide>
                    <slide>
                        <!-- <div class="carousel-caption">
                            <h4>
                                <md-icon>location_on</md-icon>
                                Yellowstone National Park, United States
                            </h4>
                        </div> -->
                        <img :src="carousel3" alt="carousel3" />
                    </slide>
                    <slide>
                        <!-- <div class="carousel-caption">
                            <h4>
                                <md-icon>location_on</md-icon>
                                Yellowstone National Park, United States
                            </h4>
                        </div> -->
                        <img :src="carousel4" alt="carousel4" />
                    </slide>
                </carousel>
                <!-- </md-card> -->
            </div>
        </div>

        <div class="md-layout mt-2 md-alignment-top-center">
            <div class="md-layout-item md-xlarge-size-50 md-large-size-60 md-medium-size-90 md-small-size-95">
                <!-- Primera seccion -->
                <div v-if="!user" class="md-layout md-gutter md-alignment-top-center">
                    <div class="md-layout-item mt-1 text-align-center" @click="goPublishResource()">
                        <!-- <router-link :to="{ name: 'resource' }"> -->
                        <md-card class="md-elevation-1">
                            <md-card-content>
                                <md-button class="md-icon-button md-raised md-gray">
                                    <md-icon>publish</md-icon>
                                </md-button>
                                <div style="min-height:44px" class="">
                                    <h4 style="margin-bottom:0px">
                                        <strong>SUBIR RECURSO</strong>
                                    </h4>
                                </div>
                                <div class="welcome-cards">
                                    <span>Comparte tus materiales con otros</span>
                                </div>
                            </md-card-content>
                        </md-card>
                        <!-- </router-link> -->
                    </div>
                    <div class="md-layout-item mt-1 text-align-center">
                        <router-link :to="{ name: 'registerWin' }">
                            <md-card class="md-elevation-1">
                                <md-card-content>
                                    <md-button class="md-icon-button md-raised md-gray">
                                        <md-icon>login</md-icon>
                                    </md-button>
                                    <div style="min-height:44px" class="">
                                        <h4 style="margin-bottom:0px">
                                            <strong>REGISTRATE Y GANA</strong>
                                        </h4>
                                    </div>
                                    <div class="welcome-cards">
                                        <span>Hay beneficios de registrarse</span>
                                    </div>
                                </md-card-content>
                            </md-card>
                        </router-link>
                    </div>
                    <div class="md-layout-item mt-1 text-align-center">
                        <router-link :to="{ name: 'resources', query: { Top: 'Top' } }">
                            <md-card class="md-elevation-1">
                                <md-card-content>
                                    <md-button class="md-icon-button md-raised md-gray">
                                        <md-icon>grade</md-icon>
                                    </md-button>
                                    <div style="min-height:44px" class="">
                                        <h4 style="margin-bottom:0px">
                                            <strong>TOP 12</strong>
                                        </h4>
                                    </div>
                                    <div class="welcome-cards">
                                        <span>Los recursos más populares</span>
                                    </div>
                                </md-card-content>
                            </md-card>
                        </router-link>
                    </div>
                </div>

                <!-- Segunda seccion -->

                <div class="md-layout md-gutter md-alignment-top-center mt-3" id="category-mobile">
                    <div class="md-layout-item md-size-100 p-1">
                        <carousel
                            :per-page="4"
                            :mouse-drag="true"
                            :paginationEnabled="false"
                            :navigationEnabled="true"
                            :navigationClickTargetSize="0"
                        >
                            <slide class="text-align-center" v-for="category in categories" :value="category.id" v-bind:key="category.id">
                                <img
                                    @click="ResourcesByCategories(category.id)"
                                    :alt="category.label"
                                    :src="category.icon"
                                    width="30"
                                    class="img-category"
                                />
                                <p class=" caption-category ">
                                    {{ category.label }}
                                </p>
                                <!-- <md-button class="md-icon-button md-raised">
                                    <md-icon>class</md-icon>
                                </md-button>
                                <span class="span-small "> {{ item.label }}</span> -->
                            </slide>
                        </carousel>
                    </div>
                </div>

                <div class="md-layout mt-3 md-small-hide">
                    <div
                        class="md-layout-item text-align-center categories-home"
                        v-for="category in categories"
                        v-bind:key="category.id"
                        :value="category.id"
                    >
                        <img @click="ResourcesByCategories(category.id)" :alt="category.label" :src="category.icon" width="30" class="img-category" />
                        <p class=" caption-category ">
                            {{ category.label }}
                        </p>
                    </div>
                </div>

                <!-- Tecerar seccion -->
                <section>
                    <div class="md-layout md-gutter">
                        <div
                            class="md-layout-item md-xlarge-size-33 md-large-size-33 md-medium-size-33 md-small-size-100 md-gutter"
                            v-for="resource in resources"
                            :key="resource.id"
                        >
                            <card-recurso :resource="resource" :sizeTruncate="180">
                                <template slot="image">
                                    <md-card-media class="p-1 resource-img">
                                        <img @click="details(resource.id)" :src="resource.randomImage" alt="Imagen-Recurso" class="resource-img" />
                                        <!-- width="352" height="198" -->
                                    </md-card-media>
                                </template>
                                <template slot="button">
                                    <ver-recurso class="no-margin" :resource="resource"></ver-recurso>
                                </template>
                                <template slot="icon">
                                    <md-badge
                                        v-if="resource.rating"
                                        class="md-square color-badge "
                                        md-position="bottom"
                                        :md-content="resource.rating"
                                    >
                                        <md-button class="md-icon-button md-dense no-margin">
                                            <md-icon
                                                :class="{
                                                    'text-primary': resource.rating
                                                }"
                                                >star_border_purple500</md-icon
                                            >
                                        </md-button>
                                    </md-badge>
                                    <md-button v-else class="md-icon-button md-dense no-margin">
                                        <md-icon
                                            :class="{
                                                'text-primary': resource.rating
                                            }"
                                            >star_border_purple500</md-icon
                                        >
                                    </md-button>
                                </template>
                            </card-recurso>
                        </div>

                        <div v-if="pageCount" class="md-layout mt-3 md-alignment-top-center">
                            <pagination class="mt-2" v-model="page" :page-count="pageCount"></pagination>
                        </div>
                    </div>

                    <!-- <div
                        class="md-layout md-gutter mt-2 md-alignment-top-center"
                    >
                        <md-button
                            class="btn-ver md-dense md-raised md-primary"
                            to="/recursos"
                            >Ver más</md-button
                        >
                    </div> -->
                </section>

                <section v-if="user && poll.hasVoted == false">
                    <div class="md-layout md-gutter mt-3">
                        <div class="md-layout-item md-size-66 md-small-size-100">
                            <md-card id="card-cuestion">
                                <md-card-header>
                                    <md-card-header-text>
                                        <div class="md-subhead">ENCUESTA</div>
                                        <div class="md-title">
                                            {{ poll.question }}
                                        </div>
                                    </md-card-header-text>
                                </md-card-header>

                                <md-card-content>
                                    <div v-for="options in poll.options" :key="options.id">
                                        <md-radio :value="options.id" v-model="radio" class="color-primary">{{ options.option }}</md-radio>
                                    </div>
                                    <md-button class="md-raised md-primary no-margin" @click="SavePoll()">VOTAR</md-button>
                                </md-card-content>
                            </md-card>
                        </div>
                    </div>
                </section>

                <section v-if="user && poll.hasVoted == true">
                    <div class="md-layout md-gutter mt-3">
                        <div class="md-layout-item md-size-66 md-small-size-100">
                            <md-card id="card-cuestion">
                                <md-card-header>
                                    <md-card-header-text>
                                        <div class="md-subhead">ENCUESTA</div>
                                        <div class="md-title">
                                            {{ poll.question }}
                                        </div>
                                    </md-card-header-text>
                                </md-card-header>

                                <md-card-content>
                                    <div class="md-layout mb-1" v-for="options in statisticsPoll" :key="options.name">
                                        <div class="md-layout-item">
                                            <label>{{ options.name }}</label>
                                        </div>
                                        <div class="md-layout-item">
                                            <md-progress-bar md-mode="determinate" :md-value="options.porcent"></md-progress-bar>
                                        </div>
                                        <div class="md-layout-item ml-1">
                                            <label>{{ options.porcent }} %</label>
                                        </div>
                                    </div>
                                </md-card-content>
                            </md-card>
                        </div>
                    </div>
                </section>
            </div>
        </div>
    </div>
</template>

<script>
import axios from 'axios';
import CardRecurso from './components/Recursos/CardRecurso.vue';
import VerRecurso from './components/Recursos/VerRecurso.vue';
import Pagination from '../components/Pagination.vue';
export default {
    components: { CardRecurso, VerRecurso, Pagination },
    name: 'home',
    data() {
        return {
            resourcesEndPoint: '/api/homeResources',
            categoriesEndPoint: '/api/categories',
            pollEndPoint: '/api/getPoll',
            savePollEndpoin: '/api/sendPoll',
            estadisticasEndpoint: '/api/getStatisticsPoll',
            resources: [],
            poll: [],
            categories: [],
            statisticsPoll: [],
            vote: true,
            radio: true,
            itemsPerRow: 3,
            loading: false,
            paginationEnabled: false,
            carousel1: require('../assets/img/home/paralideres_web_BANNERS-01.png'),
            carousel2: require('../assets/img/home/paralideres_web_BANNERS-02.png'),
            carousel3: require('../assets/img/home/paralideres_web_BANNERS-03.png'),
            carousel4: require('../assets/img/home/paralideres_web_BANNERS-04.png'),
            page: 1,
            numResults: 12,
            pageCount: 0
        };
    },
    computed: {
        user() {
            return this.$auth.watch.data;
        },
        rowCount() {
            return Math.ceil(this.resources.length / this.itemsPerRow);
        },
        display() {
            // if (this.resource) {
            //     return {
            //         display: none
            //     }
            // }
        }
    },
    watch: {
        page(val) {
            this.getResources();
        }
    },
    methods: {
        details(id) {
            this.$router.push({ path: `/recursos/${id}` });
        },
        ResourcesByCategories(id) {
            // if(resource.total_resources){
            let categoriesId = [];

            // resource.categories_info.forEach(element => {
            categoriesId.push(id);
            // });
            this.$router.push({
                name: 'resources',
                query: { categories: categoriesId }
            });
            // }else {
            //     this.$root.WarnMgs("Sin recursos.");
            // }
        },
        goPublishResource() {
            if (this.user != null) {
                this.$router.push({
                    name: 'resource'
                });
            } else {
                this.$root.WarnMgs('Es necesario iniciar sesión.');
            }
        },
        getCategories() {
            axios
                .get(this.categoriesEndPoint)
                .then((res) => {
                    if (res && res.data && res.data.categories) {
                        this.categories = res.data.categories;
                    } else {
                        this.categories = [];
                    }
                })
                .catch((error) => {
                    console.log('Error GetCategories' + error);
                });
        },
        getResources() {
            this.loading = true;
            axios
                .get(`${this.resourcesEndPoint}?page=${this.page}&num_results=${this.numResults}`)
                .then((res) => {
                    if (res && res.data && res.data.data.data) {
                        this.resources = Object.assign([], res.data.data.data);
                        this.pageCount = res.data.data.total_pages;
                    } else {
                        this.resources = [];
                    }
                })
                .catch((error) => {
                    console.log('Error getResources' + error);
                })
                .finally(() => {
                    this.loading = false;
                });
        },
        itemCountInRow(index) {
            return this.resources.slice((index - 1) * this.itemsPerRow, index * this.itemsPerRow);
        },
        getPollandPollOption() {
            axios
                .get(this.pollEndPoint)
                .then((res) => {
                    if (res && res.data && res.data.data) {
                        this.poll = res.data.data;
                        if (this.poll.hasVoted == true) {
                            this.getStatisticsPoll();
                        }
                    } else {
                        this.poll = [];
                    }
                })
                .catch((error) => {
                    console.log('Error getPollandPollOption' + error);
                });
        },
        SavePoll() {
            this.loading = true;
            let data = {
                poll_id: this.poll.id,
                poll_options_id: this.radio
            };
            axios
                .post(this.savePollEndpoin, data)
                .then((res) => {
                    if (res && res.data) {
                        console.log('encuesta enviada');
                        this.$root.SuccessMgs(res.data.message);
                        this.poll.hasVoted = true;
                        this.getStatisticsPoll();
                    }
                })
                .catch((error) => {
                    this.console('Error SavePoll' + error);
                    this.$root.ErrorMgs('Error enviar el voto.');
                })
                .finally(() => {
                    this.loading = false;
                });
        },
        getStatisticsPoll() {
            axios
                .get(this.estadisticasEndpoint)
                .then((res) => {
                    if (res && res.data && res.data.data) {
                        this.statisticsPoll = res.data.data;
                    } else {
                        this.statisticsPoll = [];
                    }
                })
                .catch((error) => {
                    console.log('Error getStatisticsPoll' + error);
                });
        }
    },
    mounted() {
        this.getResources();
        this.getCategories();
        if (this.user != null) {
            this.getPollandPollOption();
        }
    }
};
</script>

<style lang="scss" scoped>
.card-reservation {
    margin-top: 8px;
    display: flex;
    align-items: center;
    justify-content: space-between;

    .md-icon {
        margin: 8px;
    }
}

.md-button-group {
    display: flex;
}

#card-cuestion {
    background-color: #363c44 !important; //gray-light
    color: white;
}

.md-progress-bar {
    height: 18px;
}

.img-category {
    display: block;
    margin: auto;
    cursor: pointer;
}

.categories-home {
    margin-right: 6px;
}

.caption-category {
    line-height: 12px;
    font-size: 11px;
    margin-inline: 2px;
}

.welcome-cards {
    min-height: 3rem;
}
.resource-img {
    cursor: pointer !important;
}
</style>
